(defun txt-err(er) ;-------------------- Error handling
  (if (/= er "Function cancelled")
      (princ (strcat "\nError: " er))
  )
  (setq *error* olderr)
  (prin1)
)

(defun c:ED (/ en nl i et et1 n txt t-d e2)
  (setq olderr *error* *error* txt-err)
  (prompt "\Select Text")
  (setq en (ssget))
  (setq nl (sslength en))
  (setq i 0)
  (setq n (- nl 1))
  (while (<= i n)
   (setq e2 (ssname en i))
   (redraw e2 3)
   (setq txt (cdr (assoc 1 (entget e2))))
   (setq t-d (cdr (assoc 0 (entget e2))))
     (if (or (= t-d "TEXT") (= t-d "DIMENSION") (= t-d "MTEXT"))
	 (progn
	    (setq dcl (load_dialog "ED.dcl"))
	    (if (not (new_dialog "ED" dcl)) (exit))
	    (set_tile "t_c" txt)
	    (action_tile "t_c" "(setq et1 $value)")
	    (setq Ok (start_dialog))
	    (unload_dialog dcl)
		(if (= 1 Ok)
		    (progn
			   (if (= et1 nil) (setq txtt txt) (setq txtt et1))
			   (cond
			     ((= t-d "TEXT" )
			      (entmod (subst (cons 1 txtt) (assoc 1 (entget e2)) (entget e2)))
			     )
			     ((= t-d "DIMENSION" )
			      (command "dim1" "newtext" txtt e2 "")
			     )
			     ((= t-d "MTEXT" )
			     (entmod (subst (cons 1 txtt) (assoc 1 (entget e2)) (entget e2)))
			     )
			   )
		    (redraw e2 5)
		    )
		);if
	 );progn
     );if
    (setq i (+ 1 i))
    (redraw e2 5)
  );while
  (setq *error* olderr)
)